chrome.runtime.onMessage.addListener(function (msg, sender, sendResponse) {
	const { type, action, data } = msg
	if (type === 'guancecloud') {
		if (action === 'updateTrack') {
			readPluginStatus(msg)
		} else {
			sendMessageToAll({ ...msg, to: 'content' })
		}
	}
})

function sendMessageToAll(message = {}) {
	console.log('===background=sendMessageToAll=')
	// 获取所有的页签
	chrome.tabs.query(
		{
			status: 'complete',
		},
		(tabs) => {
			tabs.forEach((tb) => {
				chrome.tabs.sendMessage(tb?.id, message)
			})
		}
	)
}

const localKeyPrefix = 'guancecloudrum_'
const open_status_key = 'plugin_status'
const track_list_key = 'track_list'

function readPluginStatus(msg) {
	if (chrome && chrome.storage) {
		chrome.storage.local.get([localKeyPrefix + open_status_key, localKeyPrefix + track_list_key], (result) => {
			if (result.hasOwnProperty(localKeyPrefix + open_status_key)) {
				if (result[localKeyPrefix + open_status_key] > 0) {
					chrome.action.setIcon({ path: '/images/logo.png' })
				} else {
					chrome.action.setIcon({ path: '/images/logo_gray.png' })
				}
				const data = msg?.data || {}
				// background➡️content
				sendMessageToAll({
					type: 'guancecloud',
					to: 'content',
					data: {
						...data,
						status: result[localKeyPrefix + open_status_key] > 0,
						trackID: (result[localKeyPrefix + track_list_key] || []).pop(),
					},
				})
			}
		})
	}
}
readPluginStatus()
