const localKeyPrefix = 'guancecloudrum_'
const open_status_key = 'plugin_status'
const track_list_key = 'track_list'

// 在页面上插入代码
const script = document.createElement('script')
script.setAttribute('type', 'text/javascript')
script.setAttribute('src', chrome.runtime.getURL('pageScripts/main.js'))
document.documentElement.appendChild(script)

script.addEventListener('load', () => {
	chrome.storage.local.get([localKeyPrefix + open_status_key, localKeyPrefix + track_list_key], (result) => {
		if (result.hasOwnProperty(localKeyPrefix + open_status_key)) {
			postMessage({
				data: {
					status: result[localKeyPrefix + open_status_key] > 0,
					trackID: (result[localKeyPrefix + track_list_key] || []).pop(),
				},
				action: 'updateTrack',
				type: 'guancecloud',
				to: 'pageScript',
			})
		}
	})
})
// 接收background.js传来的信息，转发给pageScript
chrome.runtime.onMessage.addListener((msg) => {
	if (msg.type === 'guancecloud') {
		postMessage({
			...msg,
			to: 'pageScript',
		})
	}
})
